
Redmine - Defect #30771

Author of issue is listed at assignee drop box

2019-02-07 13:55 - VD DV

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Permissions and roles Estimated time: 0.00 hour

Target version:    

Resolution: Wont fix Affected version: 4.0.0

Description

The issue author that has role with disabled "Issues can be assigned to this role" is still listed at Assignee dropbox (while editing the

issue).

Related issues:

Has duplicate Redmine - Defect #31466: Error assigning a task to a user whose... Closed

History

#1 - 2019-02-08 11:25 - VD DV

- File 1. Role.jpg added

- File 2. project_users_and_roles.jpg added

- File 3. assigning user that has no rights to be assigned to.jpg added

- File 4. assignment done.jpg added

This defect allows to assign issue to user that is not permitted to have issued assigned to him.

Screenshots attached.

#2 - 2019-02-09 04:11 - Go MAEDA

The author of an issue is always on the list. I think it is the expected behavior added in r4240.

#3 - 2019-02-11 10:06 - VD DV

I think that is not OK. If role does not permit user to have issues assigned to him, the role settings should be respected.

Look at this scenario:

- The reporter (user that should not have issues assigned to him) creates the issue.

- The developer (another user) is assigned through category (as default assigner for that category) of that issue.

- The developer changes status of that issue, and reasigns the issue to the reporter (by chance)

- The reporter updates the issue (the issue that is unfortunately assigned to him),

- That issue remains assigned to reporter after update.

That is wrong, especialy when the reporter have no ability to set assigner (remember that the issue is set through category defined assigner).

Even more serious is that, if reporter updates the issue, no email notification will ever come to initial assigner (developer) to further work on that issue.

The developer will never know that issue is lost out of his sight.

Is there possibility to override or disable current unwanted behaviour?

#4 - 2019-02-22 09:35 - VD DV

Is there possibility to override or disable current unwanted behaviour?

#5 - 2019-02-22 10:50 - Go MAEDA

The behavior may be ”unwanted” for you, but it is not unwanted for other people. Please see #4199.

#6 - 2019-02-22 11:14 - VD DV

I agree that some users find that behaviour useful, but some as a defect.

I suppose that it would be nice to have ability to set/unset this functionality on project settings. Maybe you can consider it as a feature.

#7 - 2019-06-20 13:19 - Go MAEDA

- Has duplicate Defect #31466: Error assigning a task to a user whose role does not allow it added
https://www.redmine.org/projects/redmine/repository/svn/revisions/4240
https://www.redmine.org/issues/4199


#8 - 2019-11-14 23:07 - Jon Schell

If you assign it back to the author, who has no role on the project, they can never assign it to anyone else.  What's the intended workaround for this

"feature"?

#9 - 2020-07-03 02:05 - Simon Hori

I found this post since we also noticed this "feature" has been making communication troubles in our organization.

It may be useful in some case according from the ticket (almost 10 years ago though), but from our point of view, we can’t even think of a reason why

it is possible to assign a ticket to someone who can’t even see it.

We hope that the design is re-considered and make it optional in the project Settings page.

Thank you for your consideration!

#10 - 2022-04-26 16:31 - VD DV

I changed this unwanted "Feature" with following dirty fix.

In file /opt/redmine-4.0.0-0/apps/redmine/htdocs/app/models/issue.rb found this code block:

  # Users the issue can be assigned to

  def assignable_users

    users = project.assignable_users(tracker).to_a

    users << author if author && author.active?

    if assigned_to_id_was.present? && assignee = Principal.find_by_id(assigned_to_id_was)

      users << assignee

    end

    users.uniq.sort

  end

... and commented line "users << author if author && author.active?":

  # Users the issue can be assigned to

  def assignable_users

    users = project.assignable_users(tracker).to_a

  #  users << author if author && author.active?

    if assigned_to_id_was.present? && assignee = Principal.find_by_id(assigned_to_id_was)

      users << assignee

    end

    users.uniq.sort

  end

 That's all.

I hope that this unwanted Feature might be considered for fixing in future releases.

#11 - 2024-08-18 07:16 - Go MAEDA

- Status changed from New to Closed

- Resolution set to Wont fix

I am closing this issue because this is not a defect but an expected behavior.

Files
